﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
#endregion

namespace MojaDrugaGraMonoGame
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        BasicEffect efekt;

        public Game1()
            : base()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            GraphicsDevice.GraphicsProfile = GraphicsProfile.Reach;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            efekt = new BasicEffect(graphics.GraphicsDevice);
            efekt.VertexColorEnabled = true;
            efekt.Projection = Matrix.CreatePerspective(
                2.0f * graphics.GraphicsDevice.Viewport.AspectRatio,
                2.0f,
                1.0f,
                10.0f);
            efekt.View = Matrix.CreateLookAt(
                new Vector3(0, 0, 2.5f),
                new Vector3(0, 0, 0),
                new Vector3(0, 1, 0)
                );
            efekt.World = Matrix.Identity;

            efekt.EnableDefaultLighting();
            efekt.AmbientLightColor = Color.DarkGray.ToVector3();
            efekt.DiffuseColor = Color.White.ToVector3();
            efekt.SpecularColor = Color.White.ToVector3();
            efekt.DirectionalLight0.DiffuseColor = Color.Red.ToVector3();
            efekt.DirectionalLight1.DiffuseColor = Color.Green.ToVector3();
            efekt.DirectionalLight2.DiffuseColor = Color.Blue.ToVector3();
            efekt.DirectionalLight0.SpecularColor = Color.Red.ToVector3();
            efekt.DirectionalLight1.SpecularColor = Color.Green.ToVector3();
            efekt.DirectionalLight2.SpecularColor = Color.Blue.ToVector3();            

            //this.Components.Add(new Prostopadloscian(this, efekt, 1.5f, 1.0f, 2.0f, null));

            Prostopadloscian p1 = new Prostopadloscian(this, efekt, 1.5f, 1.0f, 2.0f, Color.White);
            p1.World=Matrix.CreateScale(0.75f) * Matrix.CreateTranslation(-1, 0, 0);
            this.Components.Add(p1);

            Prostopadloscian p2 = new Prostopadloscian(this, efekt, 1.5f, 1.0f, 2.0f, Color.Crimson);
            p2.World=Matrix.CreateScale(0.75f) * Matrix.CreateTranslation(1, 0, 0);            
            this.Components.Add(p2);

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();

            foreach (GameComponent komponent in this.Components)
            {
                if (komponent is Prostopadloscian)
                    //(komponent as Prostopadloscian).World *=
                    //    Matrix.CreateRotationX(gameTime.ElapsedGameTime.Milliseconds / 1000.0f) *
                    //    Matrix.CreateRotationY(gameTime.ElapsedGameTime.Milliseconds / 1000.0f);
                    (komponent as Prostopadloscian).World =
                        Matrix.CreateRotationX(gameTime.ElapsedGameTime.Milliseconds / 10000.0f) *
                        Matrix.CreateRotationY(gameTime.ElapsedGameTime.Milliseconds / 10000.0f) *
                        (komponent as Prostopadloscian).World;
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }
    }
}
